=== debian/changelog ===
gemrb (0.8.4-1) unstable; urgency=medium

  * Import upstream version 0.8.4
  * Revert libsdl2 dependency to libsdl1.2. (Closes: #815215)
  * Increase Standards-Version to 3.9.7.
  * Fix some spelling errors.
  * Refresh patches line numbers.
  * Enable hardening options in debian/rules.
  * Update copyright dates.
  * Update Vcs-Git and Vcs-Browser URIs to https.

 -- Beren Minor <beren.minor+debian@gmail.com>  Mon, 21 Mar 2016 22:29:21 +0100
