## gemrb 0.8.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -27,6 +27,21 @@
 ENDIF(DEFINED CMAKE_BUILD_TYPE)
 
 PROJECT(gemrb)
+
+# Options list
+SET(SDL_BACKEND "Auto" CACHE STRING "libSDL version (possible values: Auto, SDL or SDL2)")
+SET_PROPERTY(CACHE SDL_BACKEND PROPERTY STRINGS Auto SDL SDL2)
+
+SET(OPENGL_BACKEND "None" CACHE STRING "OpenGL support (requires SDL2, possible values: None, OpenGL, GLES)")
+SET_PROPERTY(CACHE OPENGL_BACKEND PROPERTY STRINGS None OpenGL GLES)
+
+OPTION(USE_SDLMIXER "Enable SDL_mixer support" ON)
+OPTION(USE_OPENAL "Enable OpenAL support" ON)
+OPTION(USE_LIBVLC "Enable LibVLC support" ON)
+OPTION(USE_FREETYPE "Enable FreeType support" ON)
+OPTION(USE_PNG "Enable LibPNG support" ON)
+OPTION(USE_VORBIS "Enabe Vorbis support" ON)
+
 # try to extract the version from the source
 FILE(READ ${CMAKE_CURRENT_SOURCE_DIR}/gemrb/includes/globals.h GLOBALS)
 SET(GEMRB_VERSION "")
@@ -35,7 +50,7 @@
 if(GEMRB_VERSION STREQUAL "") # lookup failed
 	set(GEMRB_VERSION "unknown")
 endif()
-message("Detected version: ${GEMRB_VERSION}")
+message(STATUS "Detected version: ${GEMRB_VERSION}")
 unset(GLOBALS)
 
 IF(PREFIX)
@@ -118,6 +133,9 @@
 	SET_PATH( DOC_DIR "${BIN_DIR}/${PROJECT_NAME}.app/Contents/Resources" )
 	SET_PATH( LIB_DIR @loader_path/../Frameworks )
 endif (${LAYOUT} MATCHES "home")
+# convert the slashes for windows' users' convenience
+file(TO_NATIVE_PATH ${PLUGIN_DIR} DEFAULT_PLUGINS_DIR)
+file(TO_NATIVE_PATH ./Cache2/ DEFAULT_CACHE_DIR)
 
 # check if this is a release version
 SET(RC "")
@@ -127,7 +145,7 @@
 else()
 	set (GIT_VERSION 1)
 endif()
-MESSAGE("Git version bool: ${GIT_VERSION}")
+MESSAGE(STATUS "Git version bool: ${GIT_VERSION}")
 
 IF(CMAKE_CXX_COMPILER_ID MATCHES "GNU|Clang")
 	if ((NOT DISABLE_WERROR) AND GIT_VERSION)
@@ -151,6 +169,11 @@
 	IF (STACK_PROTECTOR)
 		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-stack-protector")
 	ENDIF ()
+	# use a more lenient regex for finding documented switch fallthroughs (gcc7)
+	CHECK_CXX_COMPILER_FLAG("-Wimplicit-fallthrough" FALLTHROUGH)
+	IF (FALLTHROUGH AND CMAKE_CXX_COMPILER_ID MATCHES "GNU")
+		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wimplicit-fallthrough=2")
+	ENDIF ()
 	if (WIN32)
 		# GCC 4.5.0+ has shared libstdc++ without dllimport
 		set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--enable-auto-import")
@@ -166,6 +189,39 @@
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules/")
 
+# MODULE is only available since 2.8.8, but that's too new for Travis and IRIX
+MACRO(FIND_PKG_OURS name)
+if (${CMAKE_MAJOR_VERSION} GREATER 2 OR CMAKE_MINOR_VERSION GREATER 8 OR CMAKE_PATCH_VERSION GREATER 8)
+	find_package(${name} MODULE)
+else()
+	find_package(${name})
+endif()
+ENDMACRO(FIND_PKG_OURS)
+
+IF(NOT STATIC_LINK)
+	# prevent static libraries from being selected by FIND_LIBRARY
+	LIST(REMOVE_ITEM CMAKE_FIND_LIBRARY_SUFFIXES ".a")
+ENDIF()
+
+# extra search paths for windows builds through AppVeyor
+IF(WIN32)
+	set(APPVEYOR_DEP_DIR "$ENV{APPVEYOR_DEPS}")
+	set(APPVEYOR_DEP_SEARCH_PATH
+		${APPVEYOR_DEP_DIR}/include/SDL
+		${APPVEYOR_DEP_DIR}/include/AL
+		${APPVEYOR_DEP_DIR}/include/libpng12
+		${APPVEYOR_DEP_DIR}/include/ogg
+		${APPVEYOR_DEP_DIR}/include/vorbis
+		${APPVEYOR_DEP_DIR}/include
+		${APPVEYOR_DEP_DIR}/lib
+		${APPVEYOR_DEP_DIR}
+	)
+	set(CMAKE_PREFIX_PATH ${APPVEYOR_DEP_SEARCH_PATH} ${CMAKE_PREFIX_PATH})
+	message(STATUS "SDLDIR: $ENV{SDLDIR}")
+	message(STATUS "APPVEYOR env: ${APPVEYOR_DEP_DIR}")
+	message(STATUS "APPVEYOR paths: ${APPVEYOR_DEP_SEARCH_PATH}")
+ENDIF()
+
 # Check for all the required and optional dependencies
 FIND_PACKAGE(PythonLibs 2.3 REQUIRED)
 IF(PYTHONLIBS_FOUND)
@@ -175,86 +231,68 @@
 	MESSAGE(FATAL_ERROR "Please get them (www.python.org)")
 ENDIF()
 
-INCLUDE(FindSDL)
-IF(SDL_FOUND)
-	MESSAGE(STATUS "Looking for SDL1: found")
-ELSE()
-	MESSAGE(WARNING "Looking for SDL1: not found!")
-ENDIF()
-
-# look for sdl2 if sdl1 was not found or a preference was stated
-IF(USE_SDL2 OR NOT SDL_FOUND)
+# Autodetection mechanism
+# Default priority to SDL
+# If found both backends and USE_SDL2 is active, switching to SDL2
+IF(SDL_BACKEND STREQUAL "Auto")
+	MESSAGE(STATUS "Autodetecting SDL backend...")
+	INCLUDE(FindSDL)
 	INCLUDE(FindSDL2)
-ENDIF()
-IF(SDL2_FOUND)
-	MESSAGE(STATUS "Looking for SDL2: found")
+	IF(SDL_FOUND)
+		MESSAGE(STATUS "Found SDL 1.2, switching to SDL backend.")
+		SET(SDL_BACKEND "SDL")
+	ENDIF()
+	IF((NOT SDL_FOUND AND SDL2_FOUND) OR (SDL_FOUND AND SDL2_FOUND AND USE_SDL2))
+		MESSAGE(STATUS "Found SDL 2.0, switching to SDL2 backend.")
+		SET(SDL_BACKEND "SDL2")
+	ENDIF()
+	IF(NOT (SDL_FOUND OR SDL2_FOUND))
+		MESSAGE(WARNING "No SDL or SDL2 libraries found.")
+		MESSAGE(FATAL_ERROR "Please get SDL from www.libsdl.org")
+	ENDIF()
+ENDIF()
+
+IF((SDL_BACKEND STREQUAL "SDL") AND NOT USE_SDL2)
+	INCLUDE(FindSDL)
+	IF(USE_SDLMIXER)
+		FIND_PKG_OURS(SDL_mixer)
+	ENDIF()
+ENDIF()
+
+IF((SDL_BACKEND STREQUAL "SDL2") OR USE_SDL2)
+	INCLUDE(FindSDL2)
 	# unify SDL variables, so we don't have to differentiate later
 	SET(SDL_INCLUDE_DIR ${SDL2_INCLUDE_DIR})
 	SET(SDL_LIBRARY ${SDL2_LIBRARY})
-	# skip SDL_FOUND for later use
+	SET(SDL_FOUND ${SDL2_FOUND})
+
+	IF(USE_SDLMIXER)
+		FIND_PKG_OURS(SDL2_mixer)
+		# unify variables, so we don't have to differentiate later
+		SET(SDL_MIXER_INCLUDE_DIRS ${SDL2_MIXER_INCLUDE_DIRS})
+		SET(SDL_MIXER_INCLUDE_DIRS ${SDL2_MIXER_INCLUDE_DIRS})
+		SET(SDL_MIXER_VERSION_STRING ${SDL2_MIXER_VERSION_STRING})
+		SET(SDL_MIXER_FOUND ${SDL2_MIXER_FOUND})
+	ENDIF()
+ENDIF()
+
+# backward compatibility notice - remove USE_SDL2 and OPENGL_BACKEND in the future (added mid 2016)
+IF(USE_SDL2)
+	MESSAGE(WARNING "USE_SDL2 has been deprecated, use SDL_BACKEND instead: Auto, SDL, SDL2.")
+ENDIF()
+IF(USE_OPENGL)
+	MESSAGE(WARNING "USE_OPENGL has been deprecated, use OPENGL_BACKEND instead: None, OpenGL, GLES.")
+ENDIF()
+
+IF(SDL_FOUND)
+	MESSAGE(STATUS "Looking for SDL: found")
+	# unify SDL variables, so we don't have to differentiate later
+	MESSAGE(STATUS "Looking for libSDL: found")
 ELSE()
-	MESSAGE(WARNING "Looking for SDL2: not found!")
-	IF(NOT SDL_FOUND)
-		MESSAGE(FATAL_ERROR "Please get SDL from www.libsdl.org")
-	ENDIF()
-ENDIF()
-
-IF(USE_OPENGL)
-	IF(NOT SDL2_FOUND)
-		MESSAGE(FATAL_ERROR "SDL2 is required for the OpenGL driver!")
-	ENDIF()
-	INCLUDE(FindOpenGL)
-	IF(NOT OPENGL_FOUND)
-		MESSAGE(FATAL_ERROR "OpenGL library not found!")
-	ENDIF()
-
-	IF(USE_OPENGL EQUAL 1)
-		ADD_DEFINITIONS("-DUSE_GL")
-		INCLUDE(FindGLEW)
-		IF(GLEW_FOUND)
-			MESSAGE(STATUS "Looking for Glew: found")
-		ELSE()
-			MESSAGE(SEND_ERROR "Looking for Glew: not found!")
-			MESSAGE(FATAL_ERROR "Please install the Glew library and headers first!")
-		ENDIF()
-	ELSE()
-		# use GLES instead of regular GL
-		# TODO: check for all the stuff GLES needs
-	ENDIF()
-ENDIF()
-
-INCLUDE(FindZLIB)
-IF(ZLIB_FOUND)
-	MESSAGE(STATUS "Looking for Zlib: found")
-ELSE()
-	MESSAGE(SEND_ERROR "Looking for Zlib: not found!")
-	MESSAGE(FATAL_ERROR "Please install the Zlib library and headers first!")
-ENDIF()
-
-IF(UNIX)
-	SET(CMAKE_THREAD_PREFER_PTHREAD true)
-	FIND_PACKAGE(Threads REQUIRED)
-ENDIF(UNIX)
-
-INCLUDE(FindOpenAL)
-IF(OPENAL_FOUND)
-	MESSAGE(STATUS "Looking for OpenAL: found")
-ELSE()
-	MESSAGE(WARNING "Looking for OpenAL: not found!")
-	MESSAGE(WARNING "If you want to build the OpenAL plugin, get OpenAL from www.openal.org.")
-	MESSAGE(WARNING "If it just wasn't found, try setting the OPENALDIR environment variable.")
-ENDIF()
-
-IF(SDL2_FOUND)
-	FIND_PACKAGE(SDL2_mixer MODULE)
-	# unify variables, so we don't have to differentiate later
-	SET(SDL_MIXER_INCLUDE_DIRS ${SDL2_MIXER_INCLUDE_DIRS})
-	SET(SDL_MIXER_LIBRARIES ${SDL2_MIXER_LIBRARIES})
-	SET(SDL_MIXER_VERSION_STRING ${SDL2_MIXER_VERSION_STRING})
-	SET(SDL_MIXER_FOUND ${SDL2_MIXER_FOUND})
-ELSE()
-	FIND_PACKAGE(SDL_mixer MODULE)
-ENDIF()
+	MESSAGE(WARNING "Looking for SDL: not found!")
+	MESSAGE(FATAL_ERROR "Please get SDL from www.libsdl.org")
+ENDIF()
+
 IF(SDL_MIXER_FOUND)
 	MESSAGE(STATUS "Looking for SDL_mixer: found")
 ELSE()
@@ -263,71 +301,9 @@
 	MESSAGE(WARNING "Make sure you use a version compatible with the chosen SDL version.")
 ENDIF()
 
-FIND_PACKAGE(LIBVLC MODULE)
-IF(LIBVLC_FOUND)
-	MESSAGE(STATUS "Looking for VLC: found")
-ELSE()
-	MESSAGE(WARNING "Looking for VLC: not found!")
-	MESSAGE(WARNING "If you want to build the VLC plugin, install VLC first.")
-ENDIF()
-
-INCLUDE(FindFreetype)
-IF(FREETYPE_FOUND)
-	MESSAGE(STATUS "Looking for Freetype: found")
-	INCLUDE(FindICONV)
-	IF(NOT ICONV_FOUND)
-		MESSAGE(WARNING "Iconv not found. TTF plugin will not be able to translate non-unicode compatible TLK encodings.")
-	ELSE()
-		set(HAVE_ICONV)
-	ENDIF()
-ELSE()
-	MESSAGE(WARNING "Looking for Freetype: not found!")
-	MESSAGE(WARNING "If you want to build the TTF plugin, install Freetype first.")
-ENDIF()
-
-INCLUDE(FindPNG)
-IF(PNG_FOUND)
-	MESSAGE(STATUS "Looking for libPNG: found")
-ELSE()
-	MESSAGE(WARNING "Looking for libPNG: not found!")
-	MESSAGE(WARNING "GemRB will be built without any PNG support. Get it from www.libpng.org" )
-	MESSAGE(WARNING "While no original game data is in PNG format, some mod data is and will need conversion.")
-ENDIF()
-
-FIND_LIBRARY(VORBIS_LIBRARY vorbisfile)
-IF(VORBIS_LIBRARY)
-	find_path(VORBIS_FILE vorbisfile.h PATH_SUFFIXES vorbis)
-	IF(VORBIS_FILE)
-		MESSAGE(STATUS "Looking for Ogg Vorbis support: found")
-	ELSE()
-		unset(VORBIS_LIBRARY) # disable the build for this plugin
-	ENDIF()
-ENDIF()
-IF(NOT VORBIS_LIBRARY)
-	MESSAGE(WARNING "Looking for Ogg Vorbis support: not found!")
-	MESSAGE(WARNING "While no original game data is in OGG format, some mod data is and will need conversion.")
-ENDIF()
-
-# On Release builds cmake automatically defines NDEBUG, so we
-# explicitly undefine it:
-# This matches stripped (Release) and nonstripped (RelWithDebInfo) builds
-if(CMAKE_BUILD_TYPE MATCHES "Rel.*" AND NOT MSVC)
-	ADD_DEFINITIONS("-UNDEBUG")
-endif()
-
-if (STATIC_LINK)
-	if (NOT WIN32)
-		ADD_DEFINITIONS("-DSTATIC_LINK")
-	else (NOT WIN32)
-		unset(STATIC_LINK CACHE)
-		MESSAGE(STATUS "Static linking not (yet) supported on this platform.")
-	endif (NOT WIN32)
-endif (STATIC_LINK)
-
-INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR} gemrb/includes gemrb/core)
-
-# generate config.h
-INCLUDE (config)
-
-IF(APPLE)
-	# Make sure we can find the 'ibtool' program. we need it to compile xibs
+IF((NOT OPENGL_BACKEND STREQUAL "None") OR USE_OPENGL)
+	IF(SDL_BACKEND STREQUAL "SDL")
+		MESSAGE(FATAL_ERROR "SDL2 is required for the OpenGL driver!")
+	ENDIF()
+	INCLUDE(FindOpenGL)
+	IF(NOT OPENGL_FOUND)
