=== gemrb/CMakeLists.txt ===
--- 
+++ 
@@ -47,9 +47,32 @@
 	)
 
 	SET(MACOSX_BUNDLE_ICON_FILE gemrb)
-	ADD_EXECUTABLE(gemrb MACOSX_BUNDLE ../apple/CocoaWrapper/mac/CocoaWrapper.mm ../apple/AppleLogger.mm ../apple/EmptyStringTransformer.m
-					../artwork/gemrb.icns ../apple/defaults.plist
+	SET(PRODUCT_NAME "GemRB") # for info.plist
+	
+	ADD_EXECUTABLE(gemrb MACOSX_BUNDLE
+					../apple/CocoaWrapper/mac/CocoaWrapper.mm
+					../apple/AppleLogger.mm
+					../apple/EmptyStringTransformer.m
+					../artwork/gemrb.icns
+					../apple/defaults.plist
 					${RESOURCE_FILES})
+
+	# we already link to Cocoa and we need to modify this with the ‘dylib_file’ option for non-framework SDL builds
+	STRING(REPLACE "-framework Cocoa" "" SDL_LIBRARY ${SDL_LIBRARY})
+	GET_FILENAME_COMPONENT(SDL_LIBRARY ${SDL_LIBRARY} REALPATH)
+	SET(BUNDLE_FRAMEWORK_PATH "${CMAKE_BINARY_DIR}/gemrb/${PROJECT_NAME}.app/Contents/Frameworks")
+					
+	MESSAGE(STATUS "Copying SDL: ${SDL_LIBRARY}")
+	FILE(COPY ${SDL_LIBRARY} DESTINATION ${BUNDLE_FRAMEWORK_PATH} FILE_PERMISSIONS OWNER_READ OWNER_WRITE)
+
+	GET_FILENAME_COMPONENT(SDL_BASENAME ${SDL_LIBRARY} NAME)
+	SET(SDL_LIBRARY "${BUNDLE_FRAMEWORK_PATH}/${SDL_BASENAME}")
+	
+	IF(NOT SDL_BASENAME MATCHES ".framework")
+		# change the "install name" of the copied SDL
+		ADD_CUSTOM_COMMAND(TARGET gemrb PRE_BUILD COMMAND ${CMAKE_INSTALL_NAME_TOOL} -id "@loader_path/../Frameworks/${SDL_BASENAME}" "${SDL_LIBRARY}")
+	ENDIF()
+
 	SET (BUNDLE_LOADER "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.app/Contents/MacOS/${PROJECT_NAME}") # BUNDLE_LOADER is used by plugins needing to extend the cocoa wrapper (SDLVideo).
 	SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -bundle_loader \"${BUNDLE_LOADER}\"")
 ELSE(APPLE)
