=== gemrb/tests/CMakeLists.txt ===
INSTALL( DIRECTORY minimal DESTINATION ${DATA_DIR} )
