=== gemrb/plugins/IDSImporter/CMakeLists.txt ===
ADD_GEMRB_PLUGIN (IDSImporter IDSImporter.cpp)
