=== gemrb/plugins/MOSImporter/CMakeLists.txt ===
ADD_GEMRB_PLUGIN (MOSImporter MOSImporter.cpp)
