=== gemrb/plugins/PROImporter/CMakeLists.txt ===
ADD_GEMRB_PLUGIN (PROImporter PROImporter.cpp)
