=== debian/changelog ===
gemrb (0.8.5-1) unstable; urgency=medium

  * Import upstream version 0.8.5
  * Increase Standards-Version to 4.1.1.
  * Refresh patches line numbers.
  * Update copyright dates.

 -- Beren Minor <beren.minor+debian@gmail.com>  Mon, 27 Nov 2017 19:45:37 +0100
