=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
  libsdl-mixer1.2-dev, libz-dev, libopenal-dev, libpng-dev,
  libogg-dev, libvorbis-dev, libvlc-dev, libglew-dev, libfreetype6-dev,
  dh-python
-Standards-Version: 3.9.7
+Standards-Version: 4.1.1
 Homepage: http://www.gemrb.org/
 Vcs-Git: https://anonscm.debian.org/git/pkg-games/gemrb.git
 Vcs-Browser: https://anonscm.debian.org/gitweb/?p=pkg-games/gemrb.git
