## gemrb 0.9.0%2Bdfsg

=== gemrb/plugins/GAMImporter/CMakeLists.txt ===
ADD_GEMRB_PLUGIN (GAMImporter GAMImporter.cpp)
