=== gemrb/plugins/WMPImporter/CMakeLists.txt ===
ADD_GEMRB_PLUGIN (WMPImporter WMPImporter.cpp)
